﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.Threading.Tasks;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Data;
using System.Windows.Documents;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Imaging;
using System.Windows.Navigation;
using System.Windows.Shapes;

namespace Can2Tool
{
    /// <summary>
    /// Interaktionslogik für MainWindow.xaml
    /// </summary>
    public partial class MainWindow : Window
    {
        uint CanIF = 0;
        char[] Initstring = "ED000203 ; 250".ToCharArray() ;

        public static CanalMsg TxMsg = new CanalMsg();
        public static CanalMsg RxMsg = new CanalMsg();
        
        public MainWindow()
        {
            InitializeComponent();
        }

        private void TaStart_Click(object sender, RoutedEventArgs e)
        {
            Display.Text = "Start";
            if ((CanIF = usb2can.CanalOpen(Initstring, 0)) <= 0)
            {
                Display.AppendText("\n Failed to open USB2CAN interface.");
                CanIF = 0;
            }
            else
            {
                Display.AppendText("\n Init O.K. :" + CanIF.ToString());
            }

        }

        private void TaSend_Click(object sender, RoutedEventArgs e)
        {
            TxMsg.flags = 0x00000001;
            TxMsg.id = 0x1234560A;
            TxMsg.sizeData = 8;
            TxMsg.data0 = 0x55;
            TxMsg.data1 = 0x01;
            TxMsg.data2 = 0x02;
            TxMsg.data3 = 0x03;
            TxMsg.data4 = 0x04;
            TxMsg.data5 = 0x05;
            TxMsg.data6 = 0x06;
            TxMsg.data7 = 0x07;

            int Err = usb2can.CanalSend(CanIF, ref TxMsg);
            Display.AppendText("\n Send :" + Err.ToString());
        }

        private void TaStatistic_Click(object sender, RoutedEventArgs e)
        {
            CanelStat Statistic = new CanelStat();
            int Err = usb2can.CanalGetStatistics(CanIF, ref  Statistic);
            Display.AppendText("\n Statistic :" + Err.ToString());
            Display.AppendText("\n RxCount: " + Statistic.RxCount.ToString());
            Display.AppendText("\n TxCount: " + Statistic.TxCount.ToString());

        }

        private void TaRx_Click(object sender, RoutedEventArgs e)
        {
            int Err = usb2can.CanalDataAvailable(CanIF);
            Display.Text = "Rx Count :" + Err.ToString();
            if (Err > 0)
            {
                while (usb2can.CanalDataAvailable(CanIF)>0)
                {
                    usb2can.CanalReceive(CanIF, ref RxMsg);
                    Display.AppendText("\n ID: " + RxMsg.id.ToString());

                    //Display.AppendText(" Size: " + RxMsg.sizeData.ToString());
                    
                    string strData = " Data: ";
                    strData += string.Format(" {0:X2}", RxMsg.data0);
                    strData += string.Format(" {0:X2}", RxMsg.data1);
                    strData += string.Format(" {0:X2}", RxMsg.data2);
                    strData += string.Format(" {0:X2}", RxMsg.data3);
                    strData += string.Format(" {0:X2}", RxMsg.data4);
                    strData += string.Format(" {0:X2}", RxMsg.data5);
                    strData += string.Format(" {0:X2}", RxMsg.data6);
                    strData += string.Format(" {0:X2}", RxMsg.data7);
                    Display.AppendText( strData);
                    Display.AppendText(" RxTime: " + RxMsg.timestamp.ToString());
                }
            }

        }

        private void Can2Tool_Closing(object sender, System.ComponentModel.CancelEventArgs e)
        {
            if (CanIF > 0) usb2can.CanalClose(CanIF);
        }
    }
}
